{



    ##     ###                    ###
   ####     ##                     ##
  ##  ##    ##     ### ##  ####    ##     ## ###   ####
  ##  ##    ##    ##  ##  ##  ##   #####   ### ##     ##
  ######    ##    ##  ##  ######   ##  ##  ##  ##  #####
  ##  ##    ##     #####  ##       ##  ##  ##     ##  ##
  ##  ##   ####       ##   ####   ## ###  ####     ### ##
                  #####


  ####      ##
   ##
   ##      ###    #####    ####    ####   ## ###
   ##       ##    ##  ##  ##  ##      ##   ### ##
   ##   #   ##    ##  ##  ######   #####   ##  ##
   ##  ##   ##    ##  ##  ##      ##  ##   ##
  #######  ####   ##  ##   ####    ### ## ####



    ####                                     #                      ##
   ##  ##                                   ##
  ##       ####   ##  ##  ## ###  ##  ##   #####   ####    ####    ###
  ##      ##  ##  #######  ##  ## ##  ##    ##        ##  ##  ##    ##   ######
  ##      ##  ##  #######  ##  ## ##  ##    ##     #####  ##        ##
   ##  ## ##  ##  ## # ##  #####  ##  ##    ## #  ##  ##  ##  ##    ##
    ####   ####   ##   ##  ##      ### ##    ##    ### ##  ####    ####
                          ####


                                                                           ###
                                                                            ##
                                                   ####   #####    ####     ##
                                                  ##  ##  ##  ##      ##    ##
                                                  ##  ##  ##  ##   #####    ##
                                                  ##  ##  ##  ##  ##  ##    ##
                                                   ####   ##  ##   ### ##  ####



                                                          ####           #####
                                                         ##  ##         ##   ##
 ##  ##   ####   ## ###   #####   ####    ####               ##         ##  ###
 ##  ##  ##  ##   ### ## ##          ##  ##  ##            ###          ## ####
 ##  ##  ######   ##  ##  ####    #####  ##  ##           ##            #### ##
  ####   ##       ##         ##  ##  ##  ##  ##          ##  ##    ##   ###  ##
   ##     ####   ####    #####    ### ##  ####           ######    ##    #####



}



{ =========================================================================== }
{                                   ALC.PAS                                   }
{ =========================================================================== }

program ALC;

{ ---> Calculo do polinomio caracteristico, polinomio minimo, autovalores,
       autovetores, inversa, determinante e forma de Jordan de uma matriz
       quadrada n x n.

       (C) 1988, 1989, 1990 Lenimar Nunes de Andrade
           UFPB - CCEN - Departamento de Matematica - Joao Pessoa, PB
           CCENDM03@BRUFPB.BITNET                                             }

{$E+,N+,F+,R+,B-,V-,S+}

{$M 65520, 0, 655200}

uses
  FPTCBas, Crt, Matrizes, Janelas;

var
  modo, ch: char;
  i, ordem: shortint;
  mat: MatPtr;
  param1, param2, nome: string;
  cod: integer;
  tela0, tela1, tela3, tela4, tela2, tela5: TelaPtr;
  TelaIni, HouveErro, fim: boolean;
  IndExplosao, IndImplosao, IndEsfarelamento: IndPtr;
  arq: file of byte;
  decimais, hc, largura: byte;

const
  HaCor: boolean  = true;

begin
  Assign(arq, 'ALC.DTA');
  {$I-}
  Reset(arq);
  {$I+}
  if (IOResult = 0) then
  begin
    Read(arq, decimais, hc, largura);
    HaCor := boolean(hc);
    Close(arq);
  end;

  New(tela0); New(tela1); New(tela2);
  New(tela3); New(tela4); New(tela5);  New(mat);
  New(IndExplosao); New(IndImplosao); New(IndEsfarelamento);

  if HaCor then
  begin
    LeTelaTexto('TELA0', tela0);
    LeTelaTexto('TELA1', tela1);
    LeTelaTexto('TELA2', tela2);
    LeTelaTexto('TELA3', tela3);
    LeTelaTexto('TELA4', tela4);
    LeTelaTexto('TELA5', tela5);
  end
  else
  begin
    LeTelaTexto('TELA0.SCR', tela0);
    LeTelaTexto('TELA1.SCR', tela1);
    LeTelaTexto('TELA2.SCR', tela2);
    LeTelaTexto('TELA3.SCR', tela3);
    LeTelaTexto('TELA4.SCR', tela4);
    LeTelaTexto('TELA5.SCR', tela5);
  end;

  LeIndices(IndEsfarelamento^, 'ESFARELA');
  LeIndices(IndExplosao^, 'EXPLODE');
  LeIndices(IndImplosao^, 'IMPLODE');

  TelaIni := true;
  if (ParamCount >= 2) then
  begin
    param1 := ParamStr(1); param2 := ParamStr(2);
    if (param1[1] in ['1', '2', '3']) then
    begin
      modo := param1[1];
      if (modo = '2') then
      begin
        TelaIni := false;
        nome := ParamStr(2);
      end
      else
      begin
        Val(param2, ordem, cod);
        if (cod = 0) and (ordem > 1) and (ordem <= MaxM) then
          TelaIni := false;
      end;
      HouveErro := false;
    end;
  end;

  Cls;
  if TelaIni then
  begin
    EsfarelaTela(tela0, IndEsfarelamento^);
    Delay(3000);
    if HaCor then
    begin
      SombreiaCaracter(178);
      Delay(5000);
    end;
    AbreCortina(tela5);
    ch := ReadKey;
  end;

  fim := false;
  repeat
    if TelaIni then
    begin
      nome := ''; HouveErro := false; modo := '0';
      repeat
        if modo in ['1', '2', '3'] then
          MostraTela(tela3)
        else
          AbreCortina(tela3);
        nome := ''; HouveErro := false;
        ModoDeEntrada(modo, nome);
        if (modo <> '2') and (nome <> ESC) then
        begin
          Val(nome, ordem, cod);
          if (cod <> 0) then
            Erro(4, 1, HouveErro)
          else
            if ((ordem <= 1) or (ordem > MaxM)) then Erro(5, 1, HouveErro);
        end
        else
          for i := 1 to Length(nome) do
            if not (nome[i] in CaracterValido) then Erro(6, 1, HouveErro);
      until (nome <> ESC) and (not HouveErro);
    end;
    mat^.m := ordem; mat^.n := ordem; TelaIni := true;

    case modo of
      '1' : begin
              AbreCortina(tela4);
              LeTeclado(mat^);
            end;
      '2' : LeMatrizDisco(mat^, nome, HouveErro);
      '3' : GeraMatrizAleatoria(mat^, 3);
    end;

    if (not HouveErro) then MenuPrincipal(tela1, tela2, tela3, tela4,
                            mat, IndEsfarelamento, IndExplosao, IndImplosao);
  until fim;

  Dispose(tela0); Dispose(tela1); Dispose(tela2); Dispose(tela5);
  Dispose(tela3); Dispose(tela4); Dispose(mat);
  Dispose(IndExplosao); Dispose(IndImplosao); Dispose(IndEsfarelamento);
end.

{ =========================================================================== }

